// macro to fit function depthdose to data in testem75.root

#include "TNtuple.h"
#include "TCanvas.h"
#include "TROOT.h"
#include "TF1.h"
#include "TH1.h"
#include "TLegend.h"


// negative Exponential fitting function depthdose w/ 4 parameters

#include "TMath.h"

//depthdose fucntion

Double_t depthdose(Double_t *x, Double_t *par)
{
   Double_t fitval = (par[0]+par[1]*TMath::Exp(-par[2]*x[0]))*par[3];
   return fitval;

}

  



// fitting function with three parameters but not alpha free


void dedo(){


      TF1* dedo = new TF1("dedo", depthdose, 10, 45, 4);
      dedo->SetParNames("yzero","amp","parameter", "alpha");   
      dedo->SetParameters(0,0.1,0.02, 1);
      dedo->FixParameter(3, 1);           //set alpha to 1
     

}

// fitting function with all parameters but not alpha fixed


//open file testem75 and get histogram h2
void dedao() {

 gROOT->Reset();
 gROOT->SetStyle("Plain");   //set plain TStyle
 gStyle->SetOptStat(111111); //draw statistics on plots, 0 for no output
 gStyle->SetOptFit(1111);    //draw fit results on plot, 0 for no output
 gStyle->SetPalette(57);     //set color map
 gStyle->SetOptTitle(1);    //suppress title box

//---------------------------------------------------------------------------------------------

 TNtuple *ntuple = new TNtuple("ntuple", "ntuple for DPF", "alpha:B");

TFile *h = new TFile("testem00.root");
 TH1F *h00 = (TH1F*)h->Get("h2");
 // TH1F *h75 = (TH1F*)gROOT->FindObject("h2");

  
  //performing fit
 h00->Fit(dedo,"","",10,45); 
     
  // retrieve fitFunc by name
 TF1* fitFunc00 = h00->GetFunction("dedo");

   // retrieve fit parameters
 cout << "parameter = " <<  fitFunc00->GetParameter(2) << endl;
 fitFunc00->GetParError(2);
 cout << "amp = " << fitFunc00->GetParameter("amp")<< endl;
 
 fitFunc00->Draw();

 // Initialise TNtuple

 ntuple->Fill(fitFunc00->GetParameter(3),0);

//-----------------------------------------------------------------------------------------------

 TFile *h = new TFile("testem25.root");
 TH1F *h25 = (TH1F*)h->Get("h2");

//new fit function based on previous fit function with one parameter


 TF1* ffitFunc25 = new TF1("ffitFunc25", "([0]+[1]*TMath::Exp(-[2]*x))*[3]", 10, 45);
 ffitFunc25->SetParNames("yzero","amp","parameter", "alpha");   
 ffitFunc25->SetParameters(0,0.1,0.02,1);
 ffitFunc25->FixParameter(0,fitFunc00->GetParameter(0));  //Parameter 1st will be fixed
 ffitFunc25->FixParameter(1,fitFunc00->GetParameter(1));  //Parameter 2nd will be fixed
 ffitFunc25->FixParameter(2,fitFunc00->GetParameter(2));  //Parameter 3rd will be fixed

  //performing fit
 h25->Fit(ffitFunc25 ,"","",10,45); 
     
  // retrieve fitFunc by name
 TF1* fitFunc25 = h25->GetFunction("ffitFunc25");

   // retrieve fit parameters
 cout << "alpha = " <<  fitFunc25->GetParameter(3) << endl;
 fitFunc25->GetParError(3);
// cout << "amp = " << fitFunc25->GetParameter("amp")<< endl;
 
 h25->Draw();

 ntuple->Fill(fitFunc25->GetParameter(3),0.25);


//------------------------------------------------------------------------------------------------

 TFile *h = new TFile("testem75.root");
 TH1F *h75 = (TH1F*)h->Get("h2");
 // TH1F *h75 = (TH1F*)gROOT->FindObject("h2");


 TF1* ffitFunc75 = new TF1("ffitFunc75", "([0]+[1]*TMath::Exp(-[2]*x))*[3]", 10, 45);
 ffitFunc75->SetParNames("yzero","amp","parameter", "alpha");   
 ffitFunc75->SetParameters(0,0.1,0.02,1);
 ffitFunc75->FixParameter(0,fitFunc00->GetParameter(0));  //Parameter 1st will be fixed
 ffitFunc75->FixParameter(1,fitFunc00->GetParameter(1));  //Parameter 2nd will be fixed
 ffitFunc75->FixParameter(2,fitFunc00->GetParameter(2));  //Parameter 3rd will be fixed

  //performing fit
 h75->Fit(ffitFunc75 ,"","",10,45); 
     
  // retrieve fitFunc by name
 TF1* fitFunc75 = h75->GetFunction("ffitFunc75");

   // retrieve fit parameters
 cout << "alpha = " <<  fitFunc75->GetParameter(3) << endl;
 fitFunc75->GetParError(3);
 
 h75->Draw();

 ntuple->Fill(fitFunc75->GetParameter(3),0.75); 
 ntuple->SetMarkerColor(1);
 ntuple->Draw("alpha:B");

 TFile f("ntuple_data.root", "RECREATE");
 ntuple.Write();
 f.Close;

//------------------------------------------------------------------------------------------------
 
// h100->Draw();

//   TFitResultPtr r = h75->Fit(dedo, "S");
//   r-> Print();
//   TMatrixDSym C = r->GetCorrelationMatrix():
  
//   double para[3];
//   dedo->GetParameters(para);
//   dedo->GetChisquare() ;
//   dedo->GetNDF();
 
//  dedo->GetParameters(para);
//  dedo->GetChisquare();
   // dedo->GetNDF();


   
}
/*
int main(Double_t off_main, Double_t amp_main, Double_t par_main){

    depdos(off_main, amp_main, par_main);
    dedo();
    dedao();
}
 
*/
